using ICSSoft.Common;
using ICSSoft.Entity;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ICSSoft.DataProject
{
    /// <summary>
    /// 材料出库 备料表，生产订单
    /// </summary>
    public class MOIssueDoc
    {
        private static log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private static string connString = System.Configuration.ConfigurationManager.AppSettings["ERPConnStr"];
        private static string ERPDB = System.Configuration.ConfigurationManager.AppSettings["ERPDB"];
        private static string Type = System.Configuration.ConfigurationManager.AppSettings["Type"];
        private static string CRNALL = System.Configuration.ConfigurationManager.AppSettings["MoICRDNAME"];
        public string Get(List<ICSRdrecord11> infos)
        {
            List<ICSRdrecord11> szJson = new List<ICSRdrecord11>();
            DataTable dt = null;
            DataTable dtNew = null;
            string connS = "";
            string json = "";
            if (infos.Count <= 0)
            {
                throw new Exception("传送数据为空！");
            }
            string res = string.Empty;
            SqlConnection conn = new SqlConnection();
            SqlCommand cmd = new SqlCommand();
            string sql = string.Empty;


            List<string> result = infos.Select(t => t.WorkPoint).Distinct().ToList();


            foreach (string WorkPoint in result)
            {
                try
                {
                    connS = string.Format(connString, WorkPoint);
                    conn = new System.Data.SqlClient.SqlConnection(connS);
                    conn.Open();
                    SqlTransaction sqlTran = conn.BeginTransaction();
                    cmd = new SqlCommand();
                    cmd.Transaction = sqlTran;
                    cmd.Connection = conn;
                    foreach (ICSRdrecord11 info in infos)
                    {
                        if (WorkPoint != info.WorkPoint)
                            continue;

                        ICSUserInfo userInfo = new ICSUserInfo();
                        userInfo = DBHelper.GetPersonInfo(info.User, cmd);
                        if (info.MTime < new DateTime(2000, 01, 01))
                            throw new Exception("请输入正确的操作时间：" + info.MTime);
                        sql = @"  select a.ID,iMPoIds,iordercode,cCode,a.cDepCode,c.cDepName,a.cWhCode,d.cWhName,cSource,cMaker,dnmaketime,cHandler,dnverifytime,cSourceCodeLs,b.AutoID ,irowno,b.cInvCode,iQuantity,f.MoDId,iNum,g.MoCode from rdrecord11 a
                            left join rdrecords11 b on a.ID=b.ID
                            left join Department c on a.cDepCode=c.cDepCode
                            left join Warehouse d on a.cWhCode=d.cWhCode
                            left join mom_moallocate e on b.iMPoIds=e.AllocateId
                            INNER JOIN dbo.mom_orderdetail f ON e.MoDId=f.MoDId
                            INNER JOIN dbo.mom_order g ON f.MoId=g.MoId WHERE 1=1";
                        if (!string.IsNullOrWhiteSpace(info.IssueCode))
                        {
                            sql += " and a.cCode='{0}'";
                        }
                        if (!string.IsNullOrWhiteSpace(info.MTime.ToString()))
                        {
                            sql += " and ISNULL(a.dnmodifytime ,ISNULL(a.dnverifytime , ISNULL(a.dnmodifytime , a.dnmaketime)))>='{1}'";
                        }
                        if (!string.IsNullOrWhiteSpace(info.User))
                        {
                            sql += " and a.CMAKER='{2}'";
                        }
                        sql = string.Format(sql, info.IssueCode, info.MTime, userInfo.UserName);
                        dt = DBHelper.SQlReturnData(sql, cmd);
                        if (dtNew == null)
                            dtNew = dt;
                        else
                            dtNew.Merge(dt);


                    }
                    cmd.Transaction.Commit();
                }
                catch (Exception ex)
                {
                    cmd.Transaction.Rollback();
                    log.Error(ex.Message);
                    throw new Exception(ex.Message);
                }
                finally
                {
                    if (conn.State == ConnectionState.Open)
                    {
                        conn.Close();
                    }
                    conn.Dispose();
                }
            }
            json = JsonConvert.SerializeObject(dtNew);
            return json;

        }
        public string CreateRd11(List<ICSRdrecord11> Bills)
        {
            string msg = "";
            DataTable dt = null;
              string iFatherIdTwo = string.Empty;
            
            DataSet ds = null;
            string connS = "";
            VouchKey key = new VouchKey();
            int num = 0;
            int iFatherId = 0;
        
            int iChildId = 0;
            string sql = string.Empty;
            SqlConnection conn = new SqlConnection();
            SqlCommand cmd = new SqlCommand();
            if (Bills.Count <= 0)
            {
                throw new Exception("传送数据为空！");
            }
            LogInfo(Bills);
            //MergeObject(Bills, cmd);
              List<string> result = Bills.Select(t => t.WorkPoint).Distinct().ToList();


              foreach (string WorkPoint in result)
              {
                  try
                  {
                      connS = string.Format(connString, WorkPoint);
                      conn = new System.Data.SqlClient.SqlConnection(connS);
                      conn.Open();
                      SqlTransaction sqlTran = conn.BeginTransaction();
                      cmd = new SqlCommand();
                      cmd.Transaction = sqlTran;
                      cmd.Connection = conn;
                      foreach (ICSRdrecord11 head in Bills)
                      {
                          iFatherIdTwo = "";


                          if (WorkPoint != head.WorkPoint)
                              continue;

                          ICSUserInfo userInfo = new ICSUserInfo();
                          userInfo = DBHelper.GetPersonInfo(head.User, cmd);

                          num = head.details.Count();
                          string[] ss = head.WorkPoint.Split('_');
                          ERPDB = ss[1];
                          if (!DBHelper.IsInventoryConsolidation(cmd, head.WorkPoint))
                              throw new Exception("U8正在整理现存量，请稍后再试");
                          string[] dd = CRNALL.Split('~');
                          string crdname = dd[0];
                          string carname = dd[1];
                          string surface = dd[2];
                          string cardnewcode = DBHelper.GetCardNumber(carname, cmd);
                          string cRDcode = DBHelper.GetRDCode(crdname, cmd);
                          Dictionary<string, int> dic = DBHelper.GetAllCode("" + ERPDB + "", surface, "" + num + "", head.WorkPoint);
                          iFatherId = Convert.ToInt32(dic["iFatherId"].ToString());
                          iChildId = Convert.ToInt32(dic["iChildId"].ToString());
                          DateTime date = DateTime.Now;
                          string iBaseCodeLen = DBHelper.GetAllRDCode(cardnewcode, "" + date + "", "admin", cRDcode, head.WorkPoint);
                          string DEF_ID = DBHelper.GetDefaultTemplate(cardnewcode, cmd);
                          #region 判断工单是否已关闭
                          sql = @"SELECT isnull(CloseUser,'') as CloseUser from mom_orderdetail a 
                        inner join mom_order b on a.MoId=b.MoId where b.MoCode='" + head.SourceCode + "' ";
                          DataTable dtClose = DBHelper.SQlReturnData(sql, cmd);
                          if (dtClose != null && dtClose.Rows.Count > 0)
                          {
                              if (!string.IsNullOrEmpty(dtClose.Rows[0][0].ToString()))
                              {
                                  throw new Exception("该工单行已关闭，无法领料！");
                              }
                          }
                          #endregion


                          #region 判断物料是否超额领取
                          //                   foreach (rdrecords11 body in head.details)
                          //                   {
                          //                       sql = @"SELECT isnull(b.fOutExcess,0) as fOutExcess,isnull(a.IssQty,0) as IssQty,a.Qty,a.ReplenishQty  FROM dbo.mom_moallocate a 
                          //                            LEFT JOIN dbo.Inventory b ON a.InvCode=b.cInvCode
                          //                            WHERE a.AllocateId='" + body.SourceDetailID + "'";
                          //                       DataTable dtQty = DBHelper.SQlReturnData(sql, cmd);
                          //                       if (dtQty != null && dtQty.Rows.Count > 0)
                          //                       {
                          //                           //可超领比率
                          //                           decimal fOutExcess = Convert.ToDecimal(dtQty.Rows[0]["fOutExcess"]);
                          //                           //已领数量
                          //                           decimal IssQty = Convert.ToDecimal(dtQty.Rows[0]["IssQty"]);
                          //                           //应领数量
                          //                           decimal Qty = Convert.ToDecimal(dtQty.Rows[0]["Qty"]);
                          //                           //当前可总领数量
                          //                           decimal TotalQty = Qty;// + fOutExcess * Qty;
                          //                           //补料数量
                          //                           decimal ReplenishQty = Convert.ToDecimal(dtQty.Rows[0]["ReplenishQty"]);

                          //                               string cql = @"SELECT * from Inventory where cInvCode='" + body.InvCode + "'AND bKCCutMantissa =1 AND bCutMantissa=1";
                          //                               DataTable dtInv = DBHelper.SQlReturnData(cql, cmd);
                          //                               if (dtInv != null && dtInv.Rows.Count > 0)
                          //                               {
                          //                               }
                          //                               else
                          //                               {
                          //                                   if (IssQty - ReplenishQty + body.Quantity > TotalQty)
                          //                                   {
                          //                                       throw new Exception("物料领取超过当前可领用最大数，AllocateId：" + body.SourceDetailID);
                          //                                   }
                          //                               }
                          //                               //if (IssQty + body.iQuantity > TotalQty)
                          //                               //{
                          //                               //    throw new Exception("物料领取超过当前可领用最大数，AllocateId：" + body.AllocateId);
                          //                               //}
                          //                           }
                          //                       else
                          //                       {
                          //                           throw new Exception("工单行子件不存在！AllocateId：" + body.SourceDetailID);
                          //                       }
                          //                   }

                          #endregion


                          #region 材料出库单表头
                          sql = @"INSERT INTO dbo.rdrecord11
                            ( ID ,bRdFlag ,cVouchType ,cBusType ,cSource ,cWhCode ,dDate ,
                            cCode ,cRdCode ,cDepCode,cHandler ,bTransFlag ,cMaker ,
                            dVeriDate ,bpufirst ,biafirst ,VT_ID ,bIsSTQc 
                            ,cPsPcode ,cMPoCode ,iproorderid ,bFromPreYear ,
                            bIsLsQuery ,bIsComplement ,iDiscountTaxType ,ireturncount ,iverifystate ,
                            iswfcontrolled ,dnmaketime ,dnverifytime ,bredvouch ,iPrintCount,
                            iMQuantity)

                            SELECT top 1 @ID,0,'11','领料','生产订单',@cWhCode,CONVERT(NVARCHAR(15),GETDATE(),23),
                            @cCode,@cRDcode,a.MDeptCode,@cHandler,0,@cMaker,
                            CONVERT(NVARCHAR(15),GETDATE(),23),0,0,@VT_ID,0,
                            NULL,b.MoCode,a.MoId,0,
                            0,0,0,0,0,
                            0,GETDATE(),GETDATE(),0,0,
                            NULL
                            FROM dbo.mom_orderdetail a
                            left JOIN dbo.mom_order b ON a.MoId=b.MoId 
                            left join mom_morder c on a.modid=c.modid
                            WHERE b.MoCode='" + head.SourceCode + "'";
                          cmd.Parameters.Clear();
                          cmd.Parameters.Add(new SqlParameter("@ID", iFatherId));
                          cmd.Parameters.Add(new SqlParameter("@cWhCode", head.WHCode));
                          cmd.Parameters.Add(new SqlParameter("@cCode", iBaseCodeLen));
                          cmd.Parameters.Add(new SqlParameter("@cHandler", userInfo.UserName));
                          cmd.Parameters.Add(new SqlParameter("@cMaker", userInfo.UserName));
                          cmd.Parameters.Add(new SqlParameter("@VT_ID", DEF_ID));
                          cmd.Parameters.Add(new SqlParameter("@cRDcode", cRDcode));

                          cmd.CommandText = sql;
                          try
                          {
                              int count = cmd.ExecuteNonQuery();
                              if (count <= 0)
                              {
                                  log.Error("生成材料出库单表头失败，受影响行数<=0；");
                                  throw new Exception("生成材料出库单表头失败，受影响行数<=0；");
                              }
                          }
                          catch (Exception ex)
                          {
                              log.Error("生成材料出库单表头失败" + sql, ex);
                              throw new Exception("生成材料出库单表头失败" + sql, ex);
                          }
                          #endregion

                          #region 材料出库单表体
                          int irowno = 0;
                          foreach (rdrecords11 body in head.details)
                          {
                              irowno++;
                              //if (irowno == 0)
                              //{
                              //    iChildId = iChildId;
                              //}
                              //else
                              //{
                              //    iChildId -= 1;
                              //}
                              //irowno += 1;

                              //if (head.IsReturn == "1")
                              //{
                              //    body.iQuantity = -body.iQuantity;
                              //}
                              //if (head.IsReturn == "0")
                              //{
                              //    //判断物料批号与现存量表批号是否一致、数量不能超过现存量物料数量
                              //    sql = @"SELECT cBatch,iQuantity from CurrentStock WHERE cInvCode='" + body.cInvCode + "'AND cBatch='" + body.cBatch + "'and cWhCode='" + head.cWhCode + "'";
                              //    DataTable dtItem = U8Helper.SQlReturnData(sql, cmd);
                              //    if (dtItem != null && dtItem.Rows.Count > 0)
                              //    {
                              //        if (!dtItem.Rows[0]["cBatch"].ToString().Equals(body.cBatch))
                              //        {
                              //            throw new Exception("物料条码的批号与U8现存量物料批号不一致,物料:" + body.cInvCode);
                              //        }
                              //        if (Convert.ToDecimal(dtItem.Rows[0]["iQuantity"].ToString()) < body.iQuantity)
                              //        {
                              //            throw new Exception("物料条码的数量大于U8现存量物料数量,物料:" + body.cInvCode);
                              //        }

                              //    }
                              //    else
                              //    {
                              //        throw new Exception("物料:" + body.cInvCode + "在现存量表中不存在!");
                              //    }
                              //}
                              sql = @"INSERT INTO dbo.rdrecords11
                                    ( AutoID ,ID ,cInvCode ,iQuantity ,cBatch ,iFlag ,iNum,
                                        cItemCode ,cName ,iNQuantity ,iMPoIds ,bLPUseFree ,
                                        iOriTrackID ,bCosting ,bVMIUsed ,cmocode ,invcode ,imoseq ,
                                        iopseq ,iExpiratDateCalcu ,iorderdid ,iordertype ,isotype ,
                                        ipesodid ,ipesotype ,cpesocode ,ipesoseq ,irowno ,
                                        bcanreplace ,iposflag,cFree1,cFree2,cFree3,cFree4,cFree5,cFree6,cFree7,cFree8,cFree9,cFree10)
                            SELECT @AutoID,@ID,a.InvCode,@iQuantity,@cBatch,0,@iNum,
                                	@cItemCode,null,a.Qty,a.AllocateId,0,
                                	0,1,0,c.MoCode,b.InvCode,b.SortSeq,
                                	'0000',0,0,0,0,
                                	a.AllocateId,'7',c.MoCode,b.SortSeq,@irowno,
                                    0,null,@cFree1,@cFree2,@cFree3,@cFree4,@cFree5,@cFree6,@cFree7,@cFree8,@cFree9,@cFree10
                            FROM dbo.mom_moallocate a
                            INNER JOIN dbo.mom_orderdetail b ON a.MoDId=b.MoDId
                            INNER JOIN dbo.mom_order c ON b.MoId=c.MoId
                            WHERE a.AllocateId='" + body.SourceDetailID + "'";
                              cmd.Parameters.Clear();

                              cmd.Parameters.Add(new SqlParameter("@AutoID", iChildId));
                              cmd.Parameters.Add(new SqlParameter("@iQuantity", body.Quantity));
                              cmd.Parameters.Add(new SqlParameter("@iNum", body.Amount.ToString("0.00")));
                              //cmd.Parameters.Add(new SqlParameter("@cBatch", "''"));
                              cmd.Parameters.Add(new SqlParameter("@ID", iFatherId));
                              cmd.Parameters.Add(new SqlParameter("@cCode", iBaseCodeLen));
                              cmd.Parameters.Add(new SqlParameter("@cBatch", body.BatchCode));
                              cmd.Parameters.Add(new SqlParameter("@cItemCode", body.ProjectCode));
                              cmd.Parameters.Add(new SqlParameter("@irowno", irowno));
                              cmd.Parameters.Add(new SqlParameter("@cFree1", body.cFree1));
                              cmd.Parameters.Add(new SqlParameter("@cFree2", body.cFree2));
                              cmd.Parameters.Add(new SqlParameter("@cFree3", body.cFree3));
                              cmd.Parameters.Add(new SqlParameter("@cFree4", body.cFree4));
                              cmd.Parameters.Add(new SqlParameter("@cFree5", body.cFree5));
                              cmd.Parameters.Add(new SqlParameter("@cFree6", body.cFree6));
                              cmd.Parameters.Add(new SqlParameter("@cFree7", body.cFree7));
                              cmd.Parameters.Add(new SqlParameter("@cFree8", body.cFree8));
                              cmd.Parameters.Add(new SqlParameter("@cFree9", body.cFree9));
                              cmd.Parameters.Add(new SqlParameter("@cFree10", body.cFree10));

                              cmd.CommandText = sql;
                              try
                              {
                                  int count = cmd.ExecuteNonQuery();
                                  if (count <= 0)
                                  {
                                      log.Error("生成材料出库单表体失败，受影响行数<=0；");
                                      throw new Exception("生成材料出库单表体失败，受影响行数<=0；");
                                  }
                              }
                              catch (Exception ex)
                              {
                                  log.Error("生成材料出库单表体失败" + sql, ex);
                                  throw new Exception("生成材料出库单表体失败 " + sql, ex);
                              }
                              #region 回写工单子件已领数量
                              sql = "update mom_moallocate set IssQty=isnull(IssQty,0)+" + body.Quantity + ",RequisitionIssQty=isnull(RequisitionIssQty,0)+(" + body.Quantity + ") where AllocateId='" + body.SourceDetailID + "' ";
                              DBHelper.CmdExecuteNonQuery(sql, cmd, "回写工单子件已领数量失败！");
                              #endregion

                              sql = @"select isnull(Issqty,0)fOutQuantity,isnull(qty,0)iQuantity,ISNULL(AuxQty, 0)iNum,ISNULL(NiNum, 0)NiNum,ISNULL(AuxQty, 0)-ISNULL(NiNum, 0) SiNum from mom_moallocate a
                        LEFT JOIN (select sum(iNum) NiNum,ipesodid from rdrecords11 GROUP BY ipesodid) b on a.AllocateId=b.ipesodid
                        where  a.AllocateId='" + body.SourceDetailID + "'";
                              DataTable dtDisCheck = DBHelper.SQlReturnData(sql, cmd);
                              if (dtDisCheck != null && dtDisCheck.Rows.Count > 0)
                              {
                                  foreach (DataRow item1 in dtDisCheck.Rows)
                                  {
                                      if (Convert.ToDecimal(item1["fOutQuantity"].ToString()) == Convert.ToDecimal(item1["iQuantity"].ToString()))
                                      {
                                          if (Convert.ToDecimal(item1["iNum"].ToString()) != 0)
                                          {
                                              if (Convert.ToDecimal(item1["SiNum"].ToString()) != 0)
                                              {
                                                  sql = @"Update rdrecords11 set iNum=isnull(iNum,0)+(" + item1["SiNum"].ToString() + ") where autoid='" + iChildId + "' ";
                                                  body.Amount = (Convert.ToDecimal(body.Amount.ToString("0.00"))) + (Convert.ToDecimal(item1["SiNum"].ToString()));
                                                  DBHelper.CmdExecuteNonQuery(sql, cmd, "辅计量余数处理失败！");
                                              }
                                          }
                                      }
                                  }

                              }



                              //更新现存量
                              key.cBustypeUN = "领料";
                              key.cVouchTypeUN = "11";
                              key.TableName = "IA_ST_UnAccountVouch11";
                              //DBHelper.UpdateCurrentStock(cmd, body.InvCode, head.WHCode, "", body.Quantity, key);
                              //DBHelper.UpdateCurrentStockNEW(cmd, body.InvCode, head.WHCode, body.BatchCode, body.Quantity, body.cFree1, body.cFree2, body.cFree3, body.cFree4, body.cFree5, body.cFree6, body.cFree7, body.cFree8, body.cFree9, body.cFree10, key);
                              DBHelper.UpdateCurrentStockCCGC(cmd, body.InvCode, head.WHCode, body.BatchCode, body.Quantity, body.Amount, body.cFree1,
                                      body.cFree2, body.cFree3, body.cFree4, body.cFree5, body.cFree6, body.cFree7, body.cFree8, body.cFree9, body.cFree10,
                                      "", key, "", "", "", "", 0, 0, 0, 0, 0, 0, 0, 0, iFatherId, iChildId);


                            
                              iFatherIdTwo = "'" + iFatherId + "',";
                              iChildId--;

                          }
                          #endregion
                          #region 查询
                          sql = @"  
                            select DISTINCT a.ID as ID,a.ID as IDs,cMPoCode as SourceCode ,
                           cCode as IssueCode,a.cDepCode,c.cDepName,a.cWhCode,d.cWhName,
                            cSource as SourceType,cMaker as CreateUser,dnmaketime as CreateDateTime,
                            cHandler as Checker,dnverifytime as CheckDateTime
                            from rdrecord11 a
                            left join Department c on a.cDepCode=c.cDepCode
                            left join Warehouse d on a.cWhCode=d.cWhCode
                            WHERE a.ID in ({0})

                           select DISTINCT a.ID as IDs,b.AutoID as DetailID,irowno as Sequence,b.cInvCode as InvCode 
                           ,iQuantity as Quantity,e.AllocateId as SourceDetailID,iNum as Amount,
isnull(b.cItemCode,'') ProjectCode,isnull(b.cbatch,'') cBatch,'' version ,'' brand,
isnull(b.cFree1,'') as cFree1,
isnull(b.cFree2,'') as cFree2,
isnull(b.cFree3,'') as cFree3,
isnull(b.cFree4,'') as cFree4,
isnull(b.cFree5,'') as cFree5,
isnull(b.cFree6,'') as cFree6,
isnull(b.cFree7,'') as cFree7,
isnull(b.cFree8,'') as cFree8,
isnull(b.cFree9,'') as cFree9,
isnull(b.cFree10,'') as cFree10
                            from rdrecord11 a

                            left join rdrecords11 b on a.ID=b.ID
                            left join Department c on a.cDepCode=c.cDepCode
                            left join Warehouse d on a.cWhCode=d.cWhCode
                            left join mom_moallocate e on b.iMPoIds=e.AllocateId
                            INNER JOIN dbo.mom_orderdetail f ON e.MoDId=f.MoDId

                          INNER JOIN dbo.mom_order g ON f.MoId=g.MoId WHERE a.ID in ({0})";
                          sql = string.Format(sql, iFatherIdTwo.TrimEnd(','));
                          if (ds != null)
                              ds.Merge(DBHelper.SQlReturnDataSet(sql, cmd));
                          else
                              ds = DBHelper.SQlReturnDataSet(sql, cmd);

                          #endregion
                      }
                      cmd.Transaction.Commit();

                  }
                  catch (Exception ex)
                  {
                      cmd.Transaction.Rollback();
                      log.Error(ex.Message);
                      throw new Exception(ex.Message);
                  }
                  finally
                  {
                      if (conn.State == ConnectionState.Open)
                      {
                          conn.Close();
                      }
                      conn.Dispose();
                  }
              }
            msg = JSON.DataSetToJson(ds, "details", "IDs");
            return msg;
        }




        public string MaterialAppVouchs(List<ICSRdrecord11> Bills)
        {
            string mag = "";
            string sql="";
            
            DataSet ds = null;
            string connS = "";

            string iFatherIdTwo = string.Empty;
            SqlConnection conn = new SqlConnection();

            SqlCommand cmd = new SqlCommand();

            int num = 0;


            if (Bills.Count <= 0)
            {
                throw new Exception("传送数据为空！");
            }
            LogInfo(Bills);
            List<string> result = Bills.Select(t => t.WorkPoint).Distinct().ToList();


            foreach (string WorkPoint in result)
            {
                try
                {
                    connS = string.Format(connString, WorkPoint);
                    conn = new System.Data.SqlClient.SqlConnection(connS);
                    conn.Open();
                    SqlTransaction sqlTran = conn.BeginTransaction();
                    cmd = new SqlCommand();
                    cmd.Transaction = sqlTran;
                    cmd.Connection = conn;
                    foreach (ICSRdrecord11 head in Bills)
                    {
                        iFatherIdTwo = "";
                        num = head.details.Count();
                        if (WorkPoint != head.WorkPoint)
                            continue;
                        string[] ss = head.WorkPoint.Split('_');
                        ERPDB = ss[1];
                        if (!DBHelper.IsInventoryConsolidation(cmd, head.WorkPoint))
                            throw new Exception("U8正在整理现存量，请稍后再试");

                        #region 判断物料是否超额领取
                        foreach (rdrecords11 body in head.details)
                        {
                            sql = @"SELECT isnull(fOutQuantity,0) as fOutQuantity,iQuantity FROM dbo.MaterialAppVouchs WHERE AutoID='" + body.SourceDetailID + "'";
                            DataTable dtQty = DBHelper.SQlReturnData(sql, cmd);
                            if (dtQty != null && dtQty.Rows.Count > 0)
                            {
                                //已领数量
                                decimal IssQty = Convert.ToDecimal(dtQty.Rows[0]["fOutQuantity"]);
                                //应领数量
                                decimal Qty = Convert.ToDecimal(dtQty.Rows[0]["iQuantity"]);
                                if (IssQty + body.Quantity > Qty)
                                {
                                    throw new Exception("物料领取超过当前可领用最大数，订单号：" + head.SourceCode + ",行号：" + body.Sequence + " ");
                                }
                            }
                            else
                            {
                                throw new Exception("领料申请单不存在！订单号：" + head.SourceCode);
                            }
                        }
                        #endregion

                        #region 现存量是否够领
                        //                    //if (head.IsReturn != "1")
                        //                    //{
                        //                        foreach (rdrecords11 body in head.rdcords)
                        //                        {
                        //                            sql = string.Format(@"SELECT iQuantity FROM dbo.CurrentStock 
                        //                                                WHERE cInvCode='{0}' AND cWhCode='{1}'", body.cInvCode, head.cWhCode);
                        //                            if (!string.IsNullOrWhiteSpace(body.cBatch))
                        //                                sql += " and cBatch='" + body.cBatch + "'";
                        //                            DataTable dt = DBHelper.SQlReturnData(sql, cmd);
                        //                            decimal qtyCurrent = 0;
                        //                            if (dt != null && dt.Rows.Count > 0)
                        //                            {
                        //                                qtyCurrent = Convert.ToDecimal(dt.Rows[0][0]);
                        //                                if (qtyCurrent < body.Quantity)
                        //                                {
                        //                                    throw new Exception("物料编号：" + body.cInvCode + "，现存量不足！");
                        //                                }
                        //                            }
                        //                            else
                        //                            {
                        //                                throw new Exception("该物料：" + body.cInvCode + "在U8中仓库：" + head.cWhCode + "中不存在！");
                        //                            }
                        //                        }
                        //                    //}

                        #endregion

                        ICSUserInfo userInfo = new ICSUserInfo();
                        userInfo = DBHelper.GetPersonInfo(head.User, cmd);

                        #region 材料出库单表头
                        //取得out库单的默认显示模版

                        string[] dd = CRNALL.Split('~');
                        string crdname = dd[0];
                        string carname = dd[1];
                        string surface = dd[2];
                        string cardnewcode = DBHelper.GetCardNumber(carname, cmd);

                        Dictionary<string, int> dic = DBHelper.GetAllCode("" + ERPDB + "", surface, "" + num + "", head.WorkPoint);
                        int iFatherId = Convert.ToInt32(dic["iFatherId"].ToString());
                        int iChildId = Convert.ToInt32(dic["iChildId"].ToString());
                        DateTime date = DateTime.Now;
                        string cRDcode = DBHelper.GetRDCode(crdname, cmd);
                        string iBaseCodeLen = DBHelper.GetAllRDCode(cardnewcode, "" + date + "", "admin", cRDcode, head.WorkPoint);
                        string DEF_ID = DBHelper.GetDefaultTemplate(cardnewcode, cmd);
                        //取得采购入库单单据 表头ID，表体DID
                        VouchKey key = new VouchKey();

                        sql = @"INSERT INTO dbo.rdrecord11
                                    ( ID ,bRdFlag ,cVouchType ,cBusType ,cSource ,cBusCode ,cWhCode ,
                                      dDate ,cCode ,cRdCode ,cDepCode ,cPersonCode ,cHandler ,cMemo ,
                                      bTransFlag ,cMaker ,cDefine1 ,cDefine2 ,cDefine3 ,cDefine4 ,
                                      cDefine5 ,cDefine6 ,cDefine7 ,cDefine8 ,cDefine9 ,cDefine10 ,
                                      dVeriDate ,bpufirst ,biafirst ,VT_ID ,bIsSTQc ,cDefine11 ,
                                      cDefine12 ,cDefine13 ,cDefine14 ,cDefine15 ,cDefine16 ,
                                      bOMFirst ,bFromPreYear ,bIsComplement ,iDiscountTaxType ,
                                      ireturncount ,iverifystate ,iswfcontrolled ,cModifyPerson ,
                                      dnmaketime ,dnverifytime ,bredvouch ,bmotran ,bHYVouch ,iPrintCount 
                                    )
                            SELECT @ID,0,'11','领料','领料申请单',a.cCode,@cWhCode,
                            		CONVERT(NVARCHAR(15),GETDATE(),23),@cCode,@cRdCode,a.cDepCode,a.cPersonCode,@cHandler,a.cMemo,
                            		0,@cMaker,a.cDefine1,cdefine2,a.cDefine3,a.cDefine4,
                            		a.cDefine5,a.cDefine6,a.cDefine7,a.cDefine8,a.cDefine9,a.cDefine10,
                            		CONVERT(NVARCHAR(15),GETDATE(),23),0,0,@VT_ID,0,a.cDefine11,
                            		a.cDefine12,a.cDefine13,a.cDefine14,a.cDefine15,a.cDefine16,
                            		0,0,0,0,
                            		0,0,0,'',
                            		GETDATE(),GETDATE(),0,0,0,0
                            FROM dbo.MaterialAppVouch a WHERE a.cCode='" + head.SourceCode + "'";
                        cmd.Parameters.Clear();
                        cmd.Parameters.Add(new SqlParameter("@ID", iFatherId));
                        cmd.Parameters.Add(new SqlParameter("@cWhCode", head.WHCode));
                        cmd.Parameters.Add(new SqlParameter("@cCode", iBaseCodeLen));
                        cmd.Parameters.Add(new SqlParameter("@cHandler", userInfo.UserName));
                        cmd.Parameters.Add(new SqlParameter("@cMaker", userInfo.UserName));
                        cmd.Parameters.Add(new SqlParameter("@VT_ID", DEF_ID));
                        cmd.Parameters.Add(new SqlParameter("@cRdCode", cRDcode));
                        //DBHelper.CmdExecuteNonQuery(sql, cmd, "生成材料出库单表头失败！");
                        cmd.CommandText = sql;
                        try
                        {
                            int count = cmd.ExecuteNonQuery();
                            if (count <= 0)
                            {
                                log.Error("生成材料出库单表头失败，受影响行数<=0；");
                                throw new Exception("生成材料出库单表头失败，受影响行数<=0；");
                            }
                        }
                        catch (Exception ex)
                        {
                            log.Error("生成材料出库单表头失败！SQL：\r\n" + sql, ex);
                            throw new Exception("生成材料出库单表头失败！SQL：\r\n" + sql, ex);
                        }
                        #endregion

                        #region 材料出库单表体
                        int irowno = 0;
                        foreach (rdrecords11 body in head.details)
                        {
                            irowno++;
                            //if (IsReturn == "1") 
                            //{

                            //}
                            //判断物料批号与现存量表批号是否一致and数量不能超过现存量物料数量
                            //sql = @"SELECT cBatch,iQuantity from CurrentStock WHERE cInvCode='" + body.InvCode + "'AND cBatch=''and cWhCode='" + head.WHCode + "' ";
                            sql = @"SELECT cBatch,iQuantity from CurrentStock WHERE cInvCode='" + body.InvCode + "'AND cBatch='" + body.BatchCode + @"'AND cFree1='" + body.cFree1 + @"' AND cFree2='" + body.cFree2 + @"' AND cFree3='" + body.cFree3 + @"' AND cFree4='" + body.cFree4 + @"' AND cFree5='" + body.cFree5 + @"' AND cFree6='" + body.cFree6 + @"' AND cFree7='" + body.cFree7 + @"' AND cFree8='" + body.cFree8 + @"' AND cFree9='" + body.cFree9 + @"' AND cFree10='" + body.cFree10 + @"' and cWhCode='" + head.WHCode + "'";

                            DataTable dtItem = DBHelper.SQlReturnData(sql, cmd);
                            if (dtItem != null && dtItem.Rows.Count > 0)
                            {
                                //if (!dtItem.Rows[0]["cBatch"].ToString().Equals(body.cBatch))
                                //{
                                //    throw new Exception("物料条码的批号与U8现存量物料批号不一致,物料:" + body.InvCode);
                                //}
                                if (Convert.ToDecimal(dtItem.Rows[0]["iQuantity"].ToString()) < body.Quantity)
                                {
                                    throw new Exception("物料条码的数量大于U8现存量物料数量,物料:" + body.InvCode);
                                }
                                sql = @"INSERT INTO dbo.rdrecords11
                                        ( AutoID ,ID ,cInvCode ,iQuantity ,iFlag ,cDefine22 ,iNum,iMPoIds,cmocode,imoseq,iOMoDID,iOMoMID,
                                          cDefine23 ,cDefine24 ,cDefine25 ,cDefine26 ,cDefine27 ,
                                          cItem_class ,cItemCode ,cName ,cItemCName ,iNQuantity ,
                                          cDefine28 ,cDefine29 ,cDefine30 ,cDefine31 ,cDefine32 ,
                                          cDefine33 ,cDefine34 ,cDefine35 ,cDefine36 ,cDefine37 ,
                                          bLPUseFree ,iOriTrackID ,bCosting ,bVMIUsed ,iMaIDs ,
                                          iExpiratDateCalcu ,iordertype ,isotype ,ipesotype ,irowno,
                                          cBatch,cFree1,cFree2,cFree3,cFree4,cFree5,cFree6,cFree7,cFree8,cFree9,cFree10)
                                SELECT @AutoID,@ID,a.cInvCode,@iQuantity,0,a.cDefine22,@iNum,iMPoIds,cmocode,imoseq,iOMoDID,iOMoMID,
                                		a.cDefine23,a.cDefine24,a.cDefine25,a.cDefine26,a.cDefine27,
                                		a.cItem_class,@cItemCode,a.cName,a.cItemCName,a.iQuantity,
                                		a.cDefine28,a.cDefine29,a.cDefine30,a.cDefine31,a.cDefine32,
                                		a.cDefine33,a.cDefine34,a.cDefine35,a.cDefine36,a.cDefine37,
                                		0,0,1,0,a.AutoID,
                                		0,0,0,0,@irowno,
                                        @cBatch,@cFree1,@cFree2,@cFree3,@cFree4,@cFree5,@cFree6,@cFree7,@cFree8,@cFree9,@cFree10
                                FROM dbo.MaterialAppVouchs a WHERE a.AutoID='" + body.SourceDetailID + "'";
                                cmd.Parameters.Clear();
                                cmd.Parameters.Add(new SqlParameter("@ID", iFatherId));
                                cmd.Parameters.Add(new SqlParameter("@AutoID", iChildId));
                                cmd.Parameters.Add(new SqlParameter("@iQuantity", body.Quantity));
                                cmd.Parameters.Add(new SqlParameter("@iNum", body.Amount.ToString("0.00")));
                                cmd.Parameters.Add(new SqlParameter("@irowno", irowno));
                                cmd.Parameters.Add(new SqlParameter("@cBatch", body.BatchCode));
                                cmd.Parameters.Add(new SqlParameter("@cItemCode", body.ProjectCode));
                                cmd.Parameters.Add(new SqlParameter("@cFree1", body.cFree1));
                                cmd.Parameters.Add(new SqlParameter("@cFree2", body.cFree2));
                                cmd.Parameters.Add(new SqlParameter("@cFree3", body.cFree3));
                                cmd.Parameters.Add(new SqlParameter("@cFree4", body.cFree4));
                                cmd.Parameters.Add(new SqlParameter("@cFree5", body.cFree5));
                                cmd.Parameters.Add(new SqlParameter("@cFree6", body.cFree6));
                                cmd.Parameters.Add(new SqlParameter("@cFree7", body.cFree7));
                                cmd.Parameters.Add(new SqlParameter("@cFree8", body.cFree8));
                                cmd.Parameters.Add(new SqlParameter("@cFree9", body.cFree9));
                                cmd.Parameters.Add(new SqlParameter("@cFree10", body.cFree10));
                                //DBHelper.CmdExecuteNonQuery(sql, cmd, "生成材料出库单表头失败！");
                                cmd.CommandText = sql;
                                //    SqlParameter[] paramBody = {
                                //    new SqlParameter("@AutoID",DbType.String),
                                //    new SqlParameter("@ID",DbType.String),
                                //    new SqlParameter("@iQuantity",DbType.Decimal),
                                //    new SqlParameter("@irowno",DbType.String),
                                //    new SqlParameter("@cBatch",DbType.String)
                                //};
                                //paramBody[0].Value = key.DID;
                                //paramBody[1].Value = key.ID;
                                //paramBody[2].Value = body.Quantity;
                                //paramBody[3].Value = irowno;
                                // paramBody[4].Value = body.cBatch;
                                try
                                {
                                    int count = cmd.ExecuteNonQuery();
                                    if (count <= 0)
                                    {
                                        log.Error("生成材料出库单表体失败，受影响行数<=0；");
                                        throw new Exception("生成材料出库单表体失败，受影响行数<=0；");
                                    }
                                }

                                catch (Exception ex)
                                {
                                    log.Error("生成材料出库单表体失败！SQL：\r\n" + sql, ex);
                                    throw new Exception("生成材料出库单表体失败！SQL：\r\n" + sql, ex);
                                }

                                if (head.SourceType == "委外领料申请单")
                                {
                                    #region 回写领料申请单已领数量

                                    sql = @"
update OM_MOMaterials set iSendQTY=isnull(iSendQTY,0)+(" + body.Quantity + @"),fsendapplyqty=isnull(fsendapplyqty,0)+(" + body.Quantity + @") where MOMaterialsID=(select iOMoMID from  MaterialAppVouchs where AutoID='" + body.SourceDetailID + @"') 
    UPDATE dbo.MaterialAppVouchs SET fOutQuantity=ISNULL(fOutQuantity,0)+(" + body.Quantity + ") WHERE AutoID='" + body.SourceDetailID + "'";
                                    DBHelper.CmdExecuteNonQuery(sql, cmd, "回写领料申请单已领数量失败！");
                                    #endregion
                                }
                                else
                                {
                                    #region 回写领料申请单已领数量

                                    sql = @"
update mom_moallocate set IssQty=isnull(IssQty,0)+(" + body.Quantity + "),RequisitionIssQty=isnull(RequisitionIssQty,0)+(" + body.Quantity + ") where AllocateId=(select iMPoIds from  MaterialAppVouchs where AutoID='" + body.SourceDetailID + @"') 
    UPDATE dbo.MaterialAppVouchs SET fOutQuantity=ISNULL(fOutQuantity,0)+(" + body.Quantity + ") WHERE AutoID='" + body.SourceDetailID + "'";
                                    DBHelper.CmdExecuteNonQuery(sql, cmd, "回写领料申请单已领数量失败！");
                                    #endregion
                                }
                                sql = @"select isnull(fOutQuantity,0)fOutQuantity,isnull(iQuantity,0)iQuantity,ISNULL(iNum, 0)iNum,ISNULL(NiNum, 0)NiNum,ISNULL(iNum, 0)-ISNULL(NiNum, 0) SiNum from MaterialAppVouchs a
                        LEFT JOIN (select sum(iNum) NiNum,iMaIDs from rdrecords11 GROUP BY iMaIDs) b on a.AutoID=b.iMaIDs
                        where  a.AutoID='" + body.SourceDetailID + "'";
                                DataTable dtDisCheck = DBHelper.SQlReturnData(sql, cmd);
                                if (dtDisCheck != null && dtDisCheck.Rows.Count > 0)
                                {
                                    foreach (DataRow item in dtDisCheck.Rows)
                                    {
                                        if (Convert.ToDecimal(item["fOutQuantity"].ToString()) == Convert.ToDecimal(item["iQuantity"].ToString()))
                                        {
                                            if (Convert.ToDecimal(item["iNum"].ToString()) != 0)
                                            {
                                                if (Convert.ToDecimal(item["SiNum"].ToString()) != 0)
                                                {
                                                    sql = @"Update rdrecords11 set iNum=isnull(iNum,0)+(" + item["SiNum"].ToString() + ") where autoid='" + iChildId + "' ";
                                                    body.Amount = (Convert.ToDecimal(body.Amount.ToString("0.00"))) + (Convert.ToDecimal(item["SiNum"].ToString()));
                                                    DBHelper.CmdExecuteNonQuery(sql, cmd, "辅计量余数处理失败！");
                                                }
                                            }
                                        }
                                    }

                                }



                                //更新现存量
                                key.cBustypeUN = "领料";
                                key.cVouchTypeUN = "11";
                                key.TableName = "IA_ST_UnAccountVouch11";
                                //DBHelper.UpdateCurrentStock(cmd, body.InvCode, head.WHCode, "", -body.Quantity, key);
                                //DBHelper.UpdateCurrentStockNEW(cmd, body.InvCode, head.WHCode, body.BatchCode, -body.Quantity, body.cFree1, body.cFree2, body.cFree3, body.cFree4, body.cFree5, body.cFree6, body.cFree7, body.cFree8, body.cFree9, body.cFree10, key);
                                DBHelper.UpdateCurrentStockCCGC(cmd, body.InvCode, head.WHCode, body.BatchCode, -body.Quantity, -body.Amount, body.cFree1,
                                      body.cFree2, body.cFree3, body.cFree4, body.cFree5, body.cFree6, body.cFree7, body.cFree8, body.cFree9, body.cFree10,
                                      "", key, "", "", "", "", 0, 0, 0, 0, 0, 0, 0, 0, iFatherId, iChildId);

                           

                            }
                            else
                            {
                                throw new Exception("物料:" + body.InvCode + "在现存量表中不存在!");
                            }
                            iFatherIdTwo = "'" + iFatherId + "',";
                            iChildId--;

                        }
                        #endregion



                        //DBHelper.UpdateIDandDID("rd", ErpName, head.list.Count(), cmd);
                        #region 查询
                        sql = @"  
                            select DISTINCT a.ID as ID,a.ID as IDs,cMPoCode as SourceCode ,
                           cCode as IssueCode,a.cDepCode,c.cDepName,a.cWhCode,d.cWhName,
                            cSource as SourceType,cMaker as CreateUser,dnmaketime as CreateDateTime,
                            cHandler as Checker,dnverifytime as CheckDateTime
                            from rdrecord11 a
                            left join Department c on a.cDepCode=c.cDepCode
                            left join Warehouse d on a.cWhCode=d.cWhCode
                            WHERE a.ID in ({0})

                           select DISTINCT a.ID as IDs,b.AutoID as DetailID,irowno as Sequence,b.cInvCode as InvCode 
                           ,iQuantity as Quantity,b.iMaIDs as SourceDetailID,iNum as Amount,
isnull(b.cItemCode,'') ProjectCode,isnull(b.cbatch,'') cBatch,'' version ,'' brand,
isnull(b.cFree1,'') as cFree1,
isnull(b.cFree2,'') as cFree2,
isnull(b.cFree3,'') as cFree3,
isnull(b.cFree4,'') as cFree4,
isnull(b.cFree5,'') as cFree5,
isnull(b.cFree6,'') as cFree6,
isnull(b.cFree7,'') as cFree7,
isnull(b.cFree8,'') as cFree8,
isnull(b.cFree9,'') as cFree9,
isnull(b.cFree10,'') as cFree10
                            from rdrecord11 a
                            left join rdrecords11 b on a.ID=b.ID
                            left join Department c on a.cDepCode=c.cDepCode
                            left join Warehouse d on a.cWhCode=d.cWhCode
                             WHERE a.ID in ({0})";
                        sql = string.Format(sql, iFatherIdTwo.TrimEnd(','));
                        if (ds != null)
                            ds.Merge(DBHelper.SQlReturnDataSet(sql, cmd));
                        else
                            ds = DBHelper.SQlReturnDataSet(sql, cmd);


                        //return msg;
                        #endregion

                    }
                    cmd.Transaction.Commit();
                }
                catch (Exception ex)
                {
                    cmd.Transaction.Rollback();
                    log.Error(ex.Message);
                    throw new Exception(ex.Message);
                }
                finally
                {
                    if (conn.State == ConnectionState.Open)
                    {
                        conn.Close();
                    }
                    conn.Dispose();
                }
            }
            mag = JSON.DataSetToJson(ds, "details", "IDs");
            return mag;

        }
        /// <summary>
        /// 审核材料出库单据
        /// </summary>
        /// <param name="infos"></param>
        /// <returns></returns>
        public string Approve(List<ICSRdrecord11> infos)
        {
            List<ICSRdrecord11> szJson = new List<ICSRdrecord11>();
            DataTable dt = null;
            DataTable dtNew = null;
            string connS = "";
            string json = "";
            if (infos.Count <= 0)
            {
                throw new Exception("传送数据为空！");
            }
            string res = string.Empty;
            SqlConnection conn = new SqlConnection();

            SqlCommand cmd = new SqlCommand();


            string sql = string.Empty;
              List<string> result = infos.Select(t => t.WorkPoint).Distinct().ToList();


              foreach (string WorkPoint in result)
              {
                  try
                  {
                      connS = string.Format(connString, WorkPoint);
                      conn = new System.Data.SqlClient.SqlConnection(connS);
                      conn.Open();
                      SqlTransaction sqlTran = conn.BeginTransaction();
                      cmd = new SqlCommand();
                      cmd.Transaction = sqlTran;
                      cmd.Connection = conn;
                      foreach (ICSRdrecord11 info in infos)
                      {
                          if (WorkPoint != info.WorkPoint)
                              continue;

                          if (!DBHelper.IsInventoryConsolidation(cmd, info.WorkPoint))
                              throw new Exception("U8正在整理现存量，请稍后再试");

                          ICSUserInfo userInfo = new ICSUserInfo();
                          userInfo = DBHelper.GetPersonInfo(info.User, cmd);

                          if (info.MTime < new DateTime(2000, 01, 01))
                              throw new Exception("请输入正确的操作时间：" + info.MTime);
                          sql = @"UPDATE dbo.rdrecord11  SET cHandler='" + userInfo.UserName + @"' ,
                            dVeriDate=CONVERT(VARCHAR(50),GETDATE(),112),dnverifytime=GETDATE() 
                            WHERE  ID='" + info.ID + "'";
                          DBHelper.CmdExecuteNonQuery(sql, cmd, "审核材料出库单失败！");

                      }
                      cmd.Transaction.Commit();
                  }
                  catch (Exception ex)
                  {
                      cmd.Transaction.Rollback();
                      log.Error(ex.Message);
                      throw new Exception(ex.Message);
                  }
                  finally
                  {
                      if (conn.State == ConnectionState.Open)
                      {
                          conn.Close();
                      }
                      conn.Dispose();
                  }
              }
            return json;

        }
        /// <summary>
        /// 删除材料出库单据
        /// </summary>
        /// <param name="infos"></param>
        /// <returns></returns>
        public string Delete(List<ICSRdrecord11> infos)
        {
            List<ICSRdrecord11> szJson = new List<ICSRdrecord11>();
            DataTable dt = null;
            DataTable dtNew = null;
            string connS = "";
            string json = "";
            if (infos.Count <= 0)
            {
                throw new Exception("传送数据为空！");
            }
            string res = string.Empty;
            SqlConnection conn = new SqlConnection();

            SqlCommand cmd = new SqlCommand();


            string sql = string.Empty;

             List<string> result = infos.Select(t => t.WorkPoint).Distinct().ToList();


             foreach (string WorkPoint in result)
             {
                 try
                 {
                     connS = string.Format(connString, WorkPoint);
                     conn = new System.Data.SqlClient.SqlConnection(connS);
                     conn.Open();
                     SqlTransaction sqlTran = conn.BeginTransaction();
                     cmd = new SqlCommand();
                     cmd.Transaction = sqlTran;
                     cmd.Connection = conn;
                     foreach (ICSRdrecord11 info in infos)
                     {
                         if (WorkPoint != info.WorkPoint)
                             continue;


                         if (info.MTime < new DateTime(2000, 01, 01))
                             throw new Exception("请输入正确的操作时间：" + info.MTime);
                         sql = @"delete  rdrecord11  where  rdrecord11.ID='" + info.ID + "'";
                         sql += @"delete  rdrecords11  where  rdrecords11.ID='" + info.ID + "'";
                         //UPDATE dbo.rdrecord11 a SET cHandler='" + info.User + @"' ,
                         //                            dVeriDate=CONVERT(VARCHAR(50),GETDATE(),112),dnverifytime=GETDATE() 
                         //                            WHERE a.ID='" + info.ID + "'";
                         DBHelper.CmdExecuteNonQuery(sql, cmd, "删除材料出库单失败！");

                     }
                     cmd.Transaction.Commit();
                 }
                 catch (Exception ex)
                 {
                     cmd.Transaction.Rollback();
                     log.Error(ex.Message);
                     throw new Exception(ex.Message);
                 }
                 finally
                 {
                     if (conn.State == ConnectionState.Open)
                     {
                         conn.Close();
                     }
                     conn.Dispose();
                 }
             }
            return json;

        }
        /// <summary>
        /// 记录日志
        /// </summary>
        /// <param name="Bills"></param>
        private void LogInfo(List<ICSRdrecord11> Bills)
        {
            string HeadList = string.Empty;
            string BodyList = string.Empty;
            foreach (ICSRdrecord11 head in Bills)
            {
                HeadList += "\r\n 表头主键ID：" + head.ID + "，仓库：" + head.WHCode + "，用户：" + head.User + "，站点：" + head.WorkPoint;
                foreach (rdrecords11 body in head.details)
                {
                    BodyList += "\r\n 表体主键ID： " + body.SourceDetailID + "，数量：" + body.Quantity;
                }
            }
            log.Info(HeadList);
            log.Info(BodyList);
        }

    }
}
